package com.jiuqi.script.rhino;

package .tmp;

import com.jiuqi.script.IScriptObject;
import org.mozilla.javascript.Scriptable;
import org.mozilla.javascript.ScriptableObject;

public class RhinoScriptObject extends ScriptableObject {
  public static final String CLASSNAME = "CustomScriptObject";
  
  private IScriptObject sobj;
  
  public RhinoScriptObject(IScriptObject sobj) {
    this.sobj = sobj;
  }
  
  public String getClassName() {
    return "CustomScriptObject";
  }
  
  public IScriptObject getScriptObject() {
    return this.sobj;
  }
  
  public Object[] getAllIds() {
    return getIds();
  }
  
  public Object[] getIds() {
    String[] properties = this.sobj.getPropertyNames();
    String[] functions = this.sobj.getFunctionNames();
    String[] ids = new String[properties.length + functions.length];
    System.arraycopy(properties, 0, ids, 0, properties.length);
    System.arraycopy(functions, 0, ids, properties.length, functions.length);
    return (Object[])ids;
  }
  
  public Object get(String name, Scriptable start) {
    if (this.sobj.hasFunction(name))
      return new ScriptFunction(this, name, this.sobj); 
    return this.sobj.getProperty(name);
  }
  
  public Object get(int index, Scriptable start) {
    String[] properties = this.sobj.getPropertyNames();
    if (properties.length > index)
      return this.sobj.getProperty(this.sobj.getPropertyNames()[index]); 
    return null;
  }
  
  public boolean has(String name, Scriptable start) {
    return this.sobj.hasProperty(name);
  }
  
  public boolean has(int index, Scriptable start) {
    String[] properties = this.sobj.getPropertyNames();
    if (properties.length > index)
      return this.sobj.hasProperty(this.sobj.getPropertyNames()[index]); 
    return false;
  }
  
  public void put(String name, Scriptable start, Object value) {
    this.sobj.setProperty(name, value);
  }
  
  public void delete(String name) {
    this.sobj.delProperty(name);
  }
  
  public void delete(int index) {
    String[] properties = this.sobj.getPropertyNames();
    if (properties.length > index)
      this.sobj.delProperty(this.sobj.getPropertyNames()[index]); 
  }
}
